﻿Imports System.Data
Imports System.Windows.Controls.Grid

Public Class GridDataTableCollectionViewExt    
    Inherits Syncfusion.UI.Xaml.Grid.GridDataTableCollectionViewWrapper
    Public Sub New(source As IEnumerable, grid As SfDataGrid)
        MyBase.New(source, grid)
        DataGrid = grid
    End Sub
    Protected Overrides Sub ResetFilter()        
    End Sub
End Class

Class MainWindow

    Private dtGrid1 As DataTable
    Private dtGrid2 As DataTable

    Private dvGrid1 As DataView
    Private dvGrid2 As DataView

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        Dim r As DataRow
        dtGrid1 = New DataTable()
        dvGrid1 = New DataView(dtGrid1)

        dtGrid1.Columns.Add(New DataColumn("Val", System.Type.GetType("System.Int32")))

        For i As Integer = 1 To 1000
            r = dtGrid1.NewRow
            r("Val") = i
            dtGrid1.Rows.Add(r)
        Next

        dtGrid2 = dtGrid1.Copy
        dvGrid2 = New DataView(dtGrid2)


        sdgGrid1.ItemsSource = New GridDataTableCollectionViewExt(dvGrid1, sdgGrid1)
        sdgGrid2.ItemsSource = New GridDataTableCollectionViewExt(dvGrid2, sdgGrid2)

    End Sub

    Private Sub btnFilter_Click(sender As Object, e As RoutedEventArgs)

        dvGrid1.RowFilter = "Val > 499"
        dvGrid2.RowFilter = "Val > 499"

        Console.WriteLine("dvGrid1 rec count: {0}, dvGrid2 rec count: {1}", dvGrid1.Count.ToString, dvGrid2.Count.ToString)

        MessageBox.Show("Filter applied! Grid 1 and 2 should show the same list!", "Filter Applied!", MessageBoxButton.OK, MessageBoxImage.Information)

    End Sub
End Class
